'ball4all.bas 27/6/01 by Antoni Gual    agual@eic.ictnet.es
'not a single colon, so 20 lines!

1  IF n% THEN x% = RND * 640 + 1 ELSE RANDOMIZE TIMER
2  IF n% THEN y% = RND * 480 ELSE SCREEN 12
3  IF n% THEN r% = RND * 80 + (80 \ 8) ELSE READ p%, b&
4  IF n% THEN clr% = INT(RND * 4) * 4 ELSE PALETTE p%, b&
5  IF n% THEN a = RND * 3.141592 ELSE IF p% < 15 THEN GOTO 3
6  IF n% THEN b = RND * 3.141592 / 1.5 ELSE n% = 1
7  IF n% AND x% = 0 THEN GOTO 1 ELSE x1% = CINT(COS(a) * SIN(b) * 100)
8  y1% = CINT(SIN(a) * SIN(b) * 100)
9  z1% = CINT(COS(b) * 100)
10 FOR i% = -r% TO r%
11  i1% = i% * 100 / CSNG(r%)
12  FOR j% = -SQR(r% * r% - i% * i%) TO SQR(r% * r% - i% * i%)
13    j1% = j% * 100 / CSNG(r%)
14    k1% = SQR(11000 - i1% * i1% - j1% * j1%)
15    c! = 3 * (x1% * i1% + j1% * y1% + k1% * z1%) / 10000
16    ccc% = 1 + clr% + INT(c!) + (RND > (c! - INT(c!)))
17    PSET (x% + i%, y% + j%), ccc%
18 NEXT j%, i%
19 IF LEN(INKEY$) THEN  ELSE GOTO 1
20 DATA 0,&h5,1,&h10,2,&h20,3,&h30,4,&h500,5,&h1000,6,&h2000,7,&h3000,8,&h50000,9,&h100000,10,&h200000,11,&h300000,12,&h50505,13,&h101010,14,&h202020,15,&h303030

SUB drawsphere (x%, y%, r%, clr%, scrang, vertang)
'3d shadowed sphere  drawing using dithering and a range of color palette
'by Antoni Gual  agual@eic.ictnet.es 5/2001
'inputs;
'x%, y%  position on screen
'r%      radius
'clr%    base color (the darkest one in range, it must be the lower palette nr)
'scrang  in radians direction of the light source
'vertang in radians angle of the light source to a line perpendicular to screen
'Also the shared clrng% must be set to the width of a color range
'----------------------------------------------------------------------------
SHARED clrng%
clr1% = clr% + 1
r2% = r% * r%
clrng1 = (clrng% - 1) / 10000!
r1! = 100 / CSNG(r%)
temp! = SIN(vertang) * 100
x1% = CINT(COS(scrang) * temp!)
y1% = CINT(SIN(scrang) * temp!)
z1% = CINT(COS(vertang) * 100)
FOR i% = -r% TO r%
  i2% = i% * i%
  i1% = i% * r1!
  'constant 10900 should be 10000, but because of rounding errors, 900 must
  'be added to avoid breaking the program by trying SQR of a negative number
  'the added 900 causes the black dots in the brightest part of the ball
  'if someone knows how to avoid this correction, please email me.
  i12% = 11000 - i1% * i1%
  a% = SQR(r2% - i2%)
  FOR j% = -a% TO a%
    j1% = j% * r1!
    k1% = SQR(i12% - j1% * j1%)
    c! = clrng1 * (x1% * i1% + j1% * y1% + k1% * z1%)
    ccc% = clr1% + INT(c!) + (RND > (c! - INT(c!)))
    'comment out next line for backlight effect
    IF ccc% < clr% THEN ccc% = clr%
    PSET (x% + i%, y% + j%), ccc%
NEXT j%, i%
END SUB

